/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Controller;

import LoginDb.DbHandler;
import java.io.IOException;
import java.io.PrintWriter;
import java.lang.reflect.InvocationTargetException;
import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.commons.beanutils.BeanUtils;
import DataEntryBean.CustomerEnrollmentBean;




/**
 *
 * @author 590685
 */
public class TradingCustomerEnrollmentServlet extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        HttpSession session = request.getSession(false);
        Connection con = null;
        CallableStatement proc = null;
        String message = "";
        String pacsId = (String) session.getAttribute("pacsId");
        String user = (String) session.getAttribute("user");

       // String ServletName = request.getParameter("handle_id");


        CustomerEnrollmentBean CustomerEnrollmentBeanObj = new CustomerEnrollmentBean();


        if ("Create".equalsIgnoreCase(ServletName)) {

            try {
              //  BeanUtils.populate(CustomerEnrollmentBeanObj, request.getParameterMap());
            } catch (IllegalAccessException ex) {
               // Logger.getLogger(TradingCustomerEnrollmentServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } catch (InvocationTargetException ex) {
               // Logger.getLogger(TradingCustomerEnrollmentServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            }

            try {
                con = DbHandler.getDBConnection();
                try {
                    proc = con.prepareCall("{ call trading_operation.trading_customer_upsert(?,?,?,?,?,?,?,?,?,?,?) }");
                } catch (SQLException ex) {
                   // Logger.getLogger(TradingCustomerEnrollmentServlet.class.getName()).log(Level.SEVERE, null, ex);
                   System.out.println("Error occurred during processing.");
                }

               proc.setString(1, CustomerEnrollmentBeanObj.getCustomer_id());
                proc.setString(2, CustomerEnrollmentBeanObj.getName());
                proc.setString(3, CustomerEnrollmentBeanObj.getAddress());
                 proc.setString(4, CustomerEnrollmentBeanObj.getPhone());
                proc.setString(5, CustomerEnrollmentBeanObj.getContactperson());
                proc.setString(6, CustomerEnrollmentBeanObj.getCheckOption1());
                proc.setString(7, CustomerEnrollmentBeanObj.getCif_no());
                proc.setString(8, pacsId);
                proc.setString(9, ServletName);
                
                proc.registerOutParameter(10, java.sql.Types.VARCHAR);
                proc.setString(11, CustomerEnrollmentBeanObj.getGstin());
                
                proc.execute();

              //  message = proc.getString(10);

            } catch (SQLException ex) {
               // Logger.getLogger(TradingCustomerEnrollmentServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } finally {
                try {
                    proc.close();
                } catch (SQLException e) {
                    System.out.println("Error occurred during proc close.");
                }
                try {
                    con.close();
                } catch (SQLException ex) {
                   // Logger.getLogger(TradingCustomerEnrollmentServlet.class.getName()).log(Level.SEVERE, null, ex);
                   System.out.println("Error occurred during connection close.");
                }

                request.setAttribute("message", message);
                request.getRequestDispatcher("/Trading_JSP/CustomerEnrollment.jsp").forward(request, response);

            }

        } else if ("Search".equalsIgnoreCase(ServletName)) {

            try {
              //  BeanUtils.populate(CustomerEnrollmentBeanObj, request.getParameterMap());
            } catch (IllegalAccessException ex) {
               // Logger.getLogger(TradingCustomerEnrollmentServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } catch (InvocationTargetException ex) {
               // Logger.getLogger(TradingCustomerEnrollmentServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            }

            Connection connection = null;
            ResultSet rs = null;
            Statement statement = null;
            connection = DbHandler.getDBConnection();
            int SeachFound = 0;

            try {
                statement = connection.createStatement();
            } catch (SQLException ex) {
               // Logger.getLogger(TradingCustomerEnrollmentServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            }
            try {

              //  rs = statement.executeQuery("select CIF_NO, CUST_ID,CUST_NAME, CUST_ADDRESS, CONTACT_PERSON, CONTACT_NO, MEMBER_FLAG,CIF_NO from TRADING_CUSTOMER where CUST_ID= '" + CustomerEnrollmentBeanObj.getCustomer_id() + "' ");

                while (rs.next()) {

                    CustomerEnrollmentBeanObj.setName(rs.getString("CUST_NAME"));
                    CustomerEnrollmentBeanObj.setAddress(rs.getString("CUST_ADDRESS"));
                     CustomerEnrollmentBeanObj.setPhone(rs.getString("CONTACT_NO"));
                    CustomerEnrollmentBeanObj.setContactperson(rs.getString("CONTACT_PERSON"));
                    CustomerEnrollmentBeanObj.setCheckOption1(rs.getString("MEMBER_FLAG"));
                    CustomerEnrollmentBeanObj.setCif_no(rs.getString("CIF_NO"));
                    CustomerEnrollmentBeanObj.setCustomer_id(rs.getString("CUST_ID"));




                    SeachFound = 1;
                    request.setAttribute("displayFlag", "Y");

                }

               // statement.close();
               // connection.close();

            } catch (SQLException ex) {
               // Logger.getLogger(TradingCustomerEnrollmentServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } finally {
                try {
                    if(statement !=null)
                        statement.close();
                    if (connection != null)
                    connection.close();

            } catch (Exception e) {               
               System.out.println("Error Occurred during connection close.");
            }

            }

            if (SeachFound == 0) {
                message = "Customer does not exist in the system";
                request.setAttribute("message", message);
            }
            request.setAttribute("CustomerEnrollmentBeanObj", CustomerEnrollmentBeanObj);

            request.getRequestDispatcher("/Trading_JSP/CustomerEnrollment.jsp").forward(request, response);

        }

        else if ("Update".equalsIgnoreCase(ServletName)) {

            try {
              //  BeanUtils.populate(CustomerEnrollmentBeanObj, request.getParameterMap());
            } catch (IllegalAccessException ex) {
               // Logger.getLogger(TradingCustomerEnrollmentServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } catch (InvocationTargetException ex) {
               // Logger.getLogger(TradingCustomerEnrollmentServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            }

            try {
                con = DbHandler.getDBConnection();
                try {
                    proc = con.prepareCall("{ call trading_operation.trading_customer_upsert(?,?,?,?,?,?,?,?,?,?,?) }");
                } catch (SQLException ex) {
                   // Logger.getLogger(TradingCustomerEnrollmentServlet.class.getName()).log(Level.SEVERE, null, ex);
                   System.out.println("Error occurred during processing.");
                }

                 proc.setString(1, CustomerEnrollmentBeanObj.getCif_noAmend());
                proc.setString(2, CustomerEnrollmentBeanObj.getNamesearch());
                proc.setString(3, CustomerEnrollmentBeanObj.getAddressAmend());
                 proc.setString(4, CustomerEnrollmentBeanObj.getPhoneAmend());
                proc.setString(5, CustomerEnrollmentBeanObj.getContactpersonAmend());


                proc.setString(6, CustomerEnrollmentBeanObj.getCheckOption1Amend());
                proc.setString(7, CustomerEnrollmentBeanObj.getCif_noAmend());
                proc.setString(8, pacsId);
                proc.setString(9, ServletName);

                proc.registerOutParameter(10, java.sql.Types.VARCHAR);
                proc.setString(11, CustomerEnrollmentBeanObj.getGstinAmend());
                
                proc.execute();

             //   message = proc.getString(10);

            } catch (SQLException ex) {
               // Logger.getLogger(TradingCustomerEnrollmentServlet.class.getName()).log(Level.SEVERE, null, ex);
               System.out.println("Error occurred during processing.");
            } finally {
                try {
                    proc.close();
                } catch (SQLException e) {
                    System.out.println("Error occurred during proc close.");
                }
                try {
                    con.close();
                } catch (SQLException ex) {
                   // Logger.getLogger(TradingCustomerEnrollmentServlet.class.getName()).log(Level.SEVERE, null, ex);
                   System.out.println("Error occurred during connection close.");
                }

                request.setAttribute("message", message);
                request.getRequestDispatcher("/Trading_JSP/CustomerEnrollment.jsp").forward(request, response);

            }

        }

    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
